# frozen_string_literal: true

#
# botz console
#
class Botz::Console
  attr_reader :definition_file
  delegate :spiders, :scrapers, to: :definition_file

  def initialize(definition_file = nil)
    @definition_file = definition_file
  end

  def open(filepath)
    @definition_file = Botz::DefinitionFile.open(filepath)
  end

  def reload!
    @definition_file&.eval_definition
  end
end
