# frozen_string_literal: true

#
# botz interface binding
#
class Botz::DefinitionFile
  attr_reader :path
  attr_reader :definition
  delegate :spiders, :scrapers, :output, to: :definition

  CSV = lambda do |result|
    ::CSV.generate do |csv|
      csv << result.definition.attributes_to_array
    end
  end

  def self.open(filepath)
    object = new(filepath)
    object.eval_definition
    object
  end

  # rubocop:disable Security/Eval
  def eval_definition
    @definition = eval(File.open(path).read)
  end
  # rubocop:enable Security/Eval

  def shell
    @shell ||= Botz::Shell.new(self)
  end

  def console
    require 'pry'
    Pry.start(Botz::Console.new(self))
  end

  private

  def initialize(path)
    @path = path
  end
end
